You are not logged in.

#1 2012-03-14 21:20:18

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Installing git-annex

git-annex depends on outdated packages. To get around this issue, I added the haskell repository in my /etc/pacman.conf

[haskell]
Server = http://xsounds.org/~haskell/$arch

Then I am installing git-annex dependencies one by one. I am stuck at haskell-monad-control:

 % sudo pacman -S --asdeps haskell-monad-control          
resolving dependencies...
looking for inter-conflicts...
error: failed to prepare transaction (could not satisfy dependencies)
:: haddock: requires ghc=7.4.1-2
:: haskell-ghc-paths: requires ghc=7.4.1-2
:: haskell-mtl: requires haskell-transformers=0.2.2.0-4
:: haskell-xhtml: requires ghc=7.4.1-2

Any idea?

Offline

#2 2012-03-15 23:38:43

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

Ok, I don't know how to fix that, but I just realized that there are two versions of ghc available:

The one in [extra] is 7.4.1-2, while the one in [haskell] is 7.4.1-6...

Offline

#3 2012-03-15 23:42:01

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

Now if I deactivate extra, I have an issue since some packages in [haskell] depend on ghc-7.4.1-6...

Offline

#4 2012-03-16 12:30:46

Lone_Wolf
Member
From: Netherlands, Europe
Registered: 2005-10-04
Posts: 4,167

Re: Installing git-annex

Have out tried the AUR  package for git-annex ?

Last edited by Lone_Wolf (2012-03-16 12:30:55)


Booting with apg Openrc, NOT systemd.
Automounting : not needed, i prefer pmount
Aur helpers : makepkg + my own local repo === rarely need them

Offline

#5 2012-03-16 12:47:25

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

Hell yes. This the whole point of this post, I am unable to install the dependencies (haskell-monad-control is one of them).

[edit]

To make this clear:
I first tried git-annex package from AUR, and the dependency chain breaks on some AUR haskell package. Then I thought it might be a good idea to consider adding [haskell] in /etc/pacman.conf because it would probably be better maintained, but it still fails.

My goal here is to find a way to install git-annex properly, preferably in a stable way.

Last edited by duquesnc (2012-03-16 12:52:53)

Offline

#6 2012-03-16 13:14:00

Lone_Wolf
Member
From: Netherlands, Europe
Registered: 2005-10-04
Posts: 4,167

Re: Installing git-annex

Ok, so your problem is not with git-annex itself, but with one or more of it's dependencies.
Please make clear which package gives the problems, and post the output you get when building that package.


Booting with apg Openrc, NOT systemd.
Automounting : not needed, i prefer pmount
Aur helpers : makepkg + my own local repo === rarely need them

Offline

#7 2012-03-16 13:31:16

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

Ok, I'll do that. But should I use the [haskell] repository when I do that, or should I build everything from AUR?

If I use the haskell repository, the first error I have is with haskell-monad-control and I described it in my first post. To quote myself:

duquesnc wrote:
 % sudo pacman -S --asdeps haskell-monad-control          
resolving dependencies...
looking for inter-conflicts...
error: failed to prepare transaction (could not satisfy dependencies)
:: haddock: requires ghc=7.4.1-2
:: haskell-ghc-paths: requires ghc=7.4.1-2
:: haskell-mtl: requires haskell-transformers=0.2.2.0-4
:: haskell-xhtml: requires ghc=7.4.1-2

If I don't use it, the error happens elsewhere. As far as I remember - I am at work right now - the error happens when I try to build haskell-missingh, which itself has loads of dependencies, and one of them, haskell-filepath, has simply disappeared from AUR and can't be found in any repo (Furthermore haskell-missingh depends on a different version of ghc, but I guess this one can be safely modified in the PKGBUILD).

Last edited by duquesnc (2012-03-16 13:34:37)

Offline

#8 2012-03-16 14:26:23

Lone_Wolf
Member
From: Netherlands, Europe
Registered: 2005-10-04
Posts: 4,167

Re: Installing git-annex

I don't know the how well maintained the haskell repo is, but on the git-annex aur page it's not mentioned afaik.
I'd suggest to stick with core/extra/community for now.
haskell-monad-control is out-of-date and orphaned, so first task should be to update it to work with the current haskell version.

the PKGBUILD for haskell-monad-control looks rather straightforward, so i'd start by changing the required version of ghc.


Booting with apg Openrc, NOT systemd.
Automounting : not needed, i prefer pmount
Aur helpers : makepkg + my own local repo === rarely need them

Offline

#9 2012-03-18 15:00:02

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

I modified the PKGBUILD for haskell-monad-control, updating the versions of all the dependencies to what is available on AUR, but it won't build:

==> Starting build()...
Configuring monad-control-0.2.0.3...
Setup: At least the following dependencies are missing:
base >=3 && <4.5
==> ERROR: A failure occurred in build().

But what really worries me is not haskell-monad-control but haskell-missingh: it has a dependency, haskell-filepath, that _does not exist_ anywhere in AUR or the official repos. Furthermore, it has 13 other AUR dependencies that all seem more or less outdated.

Last edited by duquesnc (2012-03-18 15:10:35)

Offline

#10 2012-03-19 19:41:29

Lone_Wolf
Member
From: Netherlands, Europe
Registered: 2005-10-04
Posts: 4,167

Re: Installing git-annex

I took a brief look at haskell-missingh and understand what you mean.
You need help from other haskell/git-annex users, maybe post in the programming and scripting board of the forum ?


Booting with apg Openrc, NOT systemd.
Automounting : not needed, i prefer pmount
Aur helpers : makepkg + my own local repo === rarely need them

Offline

#11 2012-03-21 18:29:14

duquesnc
Member
Registered: 2008-12-10
Posts: 94
Website

Re: Installing git-annex

Ok, so I asked on IRC.

The good news is that git-annex is statically built, which means that once installed, it does not need the haskell libs anymore.

Solution 1
1) install cabal, install all dependencies of git-annex using cabal
2) modify git-annex's PKGBUILD and remove every haskell dependencies, install the package
3) remove cabal and all the stuff that came with it

Solution 2
Wait for the Haskell devs to add the dependencies necessary to build git-annex

Offline

#12 2012-04-07 10:08:02

dinsdale
Member
From: Riviere-du-loup
Registered: 2010-06-04
Posts: 15

Re: Installing git-annex

Thanks for writing down your experience.

Dependencies are met now but I'm getting stuck at compiling git-annex. Any idea what still might be missing or what the error means?

==> GIT checkout done or server timeout
==> Starting make...
hsc2hs Utility/StatFS.hsc
ghc -O2 -Wall -ignore-package monads-fd -ignore-package monads-tf -outputdir tmp --make configure
[1 of 6] Compiling Utility.SafeCommand ( Utility/SafeCommand.hs, tmp/Utility/SafeCommand.o )
[2 of 6] Compiling Utility.FileSystemEncoding ( Utility/FileSystemEncoding.hs, tmp/Utility/FileSystemEncoding.o )
[3 of 6] Compiling Utility.StatFS   ( Utility/StatFS.hs, tmp/Utility/StatFS.o )
[4 of 6] Compiling Build.TestConfig ( Build/TestConfig.hs, tmp/Build/TestConfig.o )
[5 of 6] Compiling Build.Configure  ( Build/Configure.hs, tmp/Build/Configure.o )
[6 of 6] Compiling Main             ( configure.hs, tmp/Main.o )
Linking configure ...
./configure
  checking StatFS... yes
  checking version... 3.20120315
  checking git... yes
  checking git version... 1.7.10
  checking cp -a... yes
  checking cp -p... yes
  checking cp --reflink=auto... yes
  checking uuid generator... uuidgen
  checking xargs -0... yes
  checking rsync... yes
  checking curl... yes
  checking wget... yes
  checking bup... no
  checking gpg... yes
  checking ssh connection caching... yes
  checking sha1... sha1sum
  checking sha256... sha256sum
  checking sha512... sha512sum
  checking sha224... sha224sum
  checking sha384... sha384sum
hsc2hs Utility/Touch.hsc
ghc -O2 -Wall -ignore-package monads-fd -ignore-package monads-tf -outputdir tmp --make git-annex

Annex/Exception.hs:14:8:
    Could not find module `Control.Exception.Lifted'
    Perhaps you meant Control.Exception.Base (from base)
    Use -v to see a list of the files searched for.
make: *** [git-annex] Error 1

Offline

#13 2012-08-31 18:48:11

kabum
Member
Registered: 2011-12-05
Posts: 6

Re: Installing git-annex

I have had a similar error. Maybe you need to include the haskell repo above all other repo definitions in /etc/pacman.conf. In my case there were some weird dependency issues.

Weird dependency issues: (german l10n)

==> git-annex dependencies:
 - git (already installed)
 - util-linux (already installed)
 - openssh (already installed)
 - rsync (already installed)
 - pcre (already installed)
 - curl (already installed)
 - ikiwiki (building from AUR)
 - ghc (package found)
 - haskell-bloomfilter (package found)
 - haskell-dataenc (package found)
 - haskell-edit-distance (package found)
 - haskell-hinotify (package found)
 - haskell-hs3 (package found)
 - haskell-hslogger (package found)
 - haskell-http (package found)
 - haskell-ifelse (package found)
 - haskell-json (package found)
 - haskell-lifted-base (package found)
 - haskell-missingh (package found)
 - haskell-monad-control (package found)
 - haskell-pcre-light (package found)
 - haskell-quickcheck (package found)
 - haskell-sha (package found)
 - haskell-stm (package found)
 - haskell-transformers-base (package found)
 - haskell-testpack (package found)
 - haskell-utf8-string (package found)


==> Edit PKGBUILD ? [Y/n] ("A" to abort)
==> ------------------------------------
==> n

==> Continue building git-annex ? [Y/n]
==> -----------------------------------
==> 
==> Building and installing package
==> Install or build missing dependencies for git-annex:
Löse Abhängigkeiten auf...
Warnung: Kann "haskell-hslogger=1.2.0-1" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-network=2.3.0.14-4" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-parsec=3.1.3-2" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-regex-base")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-json")
Warnung: Kann "haskell-parsec=3.1.3-2" nicht auflösen (eine Abhängigkeit von "haskell-json")
Warnung: Kann "haskell-transformers=0.3.0.0-2" nicht auflösen (eine Abhängigkeit von "haskell-monad-control")
Warnung: Kann "haskell-transformers=0.3.0.0-2" nicht auflösen (eine Abhängigkeit von "haskell-transformers-base")
Warnung: Kann "haskell-transformers=0.3.0.0-2" nicht auflösen (eine Abhängigkeit von "haskell-transformers-base")
Warnung: Kann "haskell-transformers=0.3.0.0-2" nicht auflösen (eine Abhängigkeit von "haskell-monad-control")
Warnung: Kann "haskell-transformers=0.3.0.0-2" nicht auflösen (eine Abhängigkeit von "haskell-transformers-base")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-edit-distance")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-ifelse")
Warnung: Kann "haskell-http=4000.2.3-7" nicht auflösen (eine Abhängigkeit von "haskell-hs3")
Warnung: Kann "haskell-dataenc=0.14.0.3-7" nicht auflösen (eine Abhängigkeit von "haskell-hs3")
Warnung: Kann "haskell-network=2.3.0.14-4" nicht auflösen (eine Abhängigkeit von "haskell-hs3")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-hs3")
Warnung: Kann "haskell-utf8-string=0.3.7-7" nicht auflösen (eine Abhängigkeit von "haskell-hs3")
Warnung: Kann "haskell-quickcheck=2.4.2-6" nicht auflösen (eine Abhängigkeit von "haskell-crypto")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-crypto")
Warnung: Kann "haskell-hslogger=1.2.0-1" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-network=2.3.0.14-4" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-parsec=3.1.3-2" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-missingh")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-hxt")
Warnung: Kann "haskell-network=2.3.0.14-4" nicht auflösen (eine Abhängigkeit von "haskell-hxt")
Warnung: Kann "haskell-parsec=3.1.3-2" nicht auflösen (eine Abhängigkeit von "haskell-hxt")
Warnung: Kann "haskell-parsec=3.1.3-2" nicht auflösen (eine Abhängigkeit von "haskell-hxt-regex-xmlschema")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-regex-base")
Warnung: Kann "haskell-quickcheck=2.4.2-6" nicht auflösen (eine Abhängigkeit von "haskell-testpack")
Warnung: Kann "haskell-mtl=2.1.2-1" nicht auflösen (eine Abhängigkeit von "haskell-testpack")
Warnung: Kann "haskell-random=1.0.1.1-7" nicht auflösen (eine Abhängigkeit von "haskell-testpack")
:: Die folgenden Pakete können aufgrund nicht-auflösbarer Abhängigkeiten nicht aktualisiert werden:
      haskell-missingh  haskell-json  haskell-monad-control  haskell-transformers-base  haskell-lifted-base  haskell-edit-distance  haskell-ifelse  haskell-hs3  haskell-testpack

Möchten Sie die obengenannten Pakete bei dieser Aktualisierung überspringen? [j/N]

First I only append the haskell repo to pacman.conf resulting in getting an older package from "extra":

$ pacman -Si haskell-mtl
Repositorium         : extra
Name           : haskell-mtl
Version              : 2.1.1-1
URL                  : http://hackage.haskell.org/package/mtl
Lizenzen             : custom:BSD3
Gruppen              : Nichts
Stellt bereit        : Nichts
Hängt ab von         : ghc=7.4.2-1  sh  haskell-transformers=0.3.0.0-1
Optionale Abhängigkeiten: Nichts
Konflikt mit         : Nichts
Ersetzt              : Nichts
Download-Größe       : 195,93 KiB
Installationsgröße   : 4036,00 KiB
Packer               : Thomas Dziedzic <gostrc@gmail.com>
Architektur          : x86_64
Erstellt am          : Mo 11 Jun 2012 03:54:03 CEST
MD5-Summe            : d73bbebbc539506df80e6351de0d3a3e
SHA256-Summe         : c6cd02b973b213443dd66c2f496b63ec1fafe92a5548dca91828820d99daf9b7
Signaturen           : Ja
Beschreibung         : Monad transformer library

Repositorium         : haskell
Name           : haskell-mtl
Version              : 2.1.2-1
URL                  : http://github.com/ekmett/mtl
Lizenzen             : BSD3
Gruppen              : Nichts
Stellt bereit        : Nichts
Hängt ab von         : ghc=7.4.2-1  haskell-transformers=0.3.0.0-2
Optionale Abhängigkeiten: Nichts
Konflikt mit         : Nichts
Ersetzt              : Nichts
Download-Größe       : 197,30 KiB
Installationsgröße   : 4048,00 KiB
Packer               : Unknown Packager
Architektur          : x86_64
Erstellt am          : Mo 25 Jun 2012 08:44:40 CEST
MD5-Summe            : 34ff9f042bba1d339050083dfd14d8fe
SHA256-Summe         : ea6127c647089598dda206b2c4c3d2b8cb13d32599cf75d8294515bb499dd591
Signaturen           : Nichts
Beschreibung         : Monad classes, using functional dependencies

After shifting the repo above "testing" repo definition in pacman.conf, all dependencies could be resolved:

$ pacman -Si haskell-mtl                                            
Repositorium         : haskell
Name           : haskell-mtl
Version              : 2.1.2-1
URL                  : http://github.com/ekmett/mtl
Lizenzen             : BSD3
Gruppen              : Nichts
Stellt bereit        : Nichts
Hängt ab von         : ghc=7.4.2-1  haskell-transformers=0.3.0.0-2
Optionale Abhängigkeiten: Nichts
Konflikt mit         : Nichts
Ersetzt              : Nichts
Download-Größe       : 197,30 KiB
Installationsgröße   : 4048,00 KiB
Packer               : Unknown Packager
Architektur          : x86_64
Erstellt am          : Mo 25 Jun 2012 08:44:40 CEST
MD5-Summe            : 34ff9f042bba1d339050083dfd14d8fe
SHA256-Summe         : ea6127c647089598dda206b2c4c3d2b8cb13d32599cf75d8294515bb499dd591
Signaturen           : Nichts
Beschreibung         : Monad classes, using functional dependencies

Repositorium         : extra
Name           : haskell-mtl
Version              : 2.1.1-1
URL                  : http://hackage.haskell.org/package/mtl
Lizenzen             : custom:BSD3
Gruppen              : Nichts
Stellt bereit        : Nichts
Hängt ab von         : ghc=7.4.2-1  sh  haskell-transformers=0.3.0.0-1
Optionale Abhängigkeiten: Nichts
Konflikt mit         : Nichts
Ersetzt              : Nichts
Download-Größe       : 195,93 KiB
Installationsgröße   : 4036,00 KiB
Packer               : Thomas Dziedzic <gostrc@gmail.com>
Architektur          : x86_64
Erstellt am          : Mo 11 Jun 2012 03:54:03 CEST
MD5-Summe            : d73bbebbc539506df80e6351de0d3a3e
SHA256-Summe         : c6cd02b973b213443dd66c2f496b63ec1fafe92a5548dca91828820d99daf9b7
Signaturen           : Ja
Beschreibung         : Monad transformer library

Hope that helps anyone smile

Offline

Board footer

Powered by FluxBB